/* -*- c-basic-offset: 2 -*-
 * GStreamer
 * Copyright (C) <1999> Erik Walthinsen <omega@cse.ogi.edu>
 *
 * Tremor modifications <2006>:
 *   Chris Lord, OpenedHand Ltd. <chris@openedhand.com>, http://www.o-hand.com/
 * More work <2007>:
 *   Tilman Vogel <tilman.vogel@web.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


#ifndef __GST_IVORBISFILE_H__
#define __GST_IVORBISFILE_H__


#include <gst/gst.h>
#include <gst/base/gstadapter.h>
#include <tremor/ivorbisfile.h>

G_BEGIN_DECLS

#define GST_TYPE_IVORBISFILE                    \
  (gst_ivorbisfile_get_type())
#define GST_IVORBISFILE(obj)                                            \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),GST_TYPE_IVORBISFILE,Ivorbisfile))
#define GST_IVORBISFILE_CLASS(klass)                                    \
  (G_TYPE_CHECK_CLASS_CAST((klass),GST_TYPE_IVORBISFILE,IvorbisfileClass))
#define GST_IS_IVORBISFILE(obj)                                 \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),GST_TYPE_IVORBISFILE))
#define GST_IS_IVORBISFILE_CLASS(klass)                           \
  (G_TYPE_CHECK_CLASS_TYPE((klass),GST_TYPE_IVORBISFILE))

GST_DEBUG_CATEGORY_EXTERN (ivorbisfile_debug);

typedef struct _Ivorbisfile Ivorbisfile;
typedef struct _IvorbisfileClass IvorbisfileClass;

/**
 * IVorbisfile:
 *
 * Opaque data structure.
 */
struct _Ivorbisfile
{
  GstElement element;

  GstPad *sinkpad, *srcpad;
  GstAdapter *adapter;
  // What was that good for?
  // guint64 adapterOffset;

  OggVorbis_File vf;
  gint current_link;

  gboolean restart;
  gboolean need_discont;
  gboolean eos;
  gboolean seek_pending;
  gint64 seek_value;
  GstFormat seek_format;
  gboolean seek_accurate;

  // may_eos is TRUE after first successful read
  gboolean may_eos;
  guint64 total_bytes;
  guint64 offset;

  gint rate;
  gint channels;
  gint width;

#if 0
  // todo: remove those
  GstCaps *metadata;
  GstCaps *streaminfo;
#endif
};

struct _IvorbisfileClass
{
  GstElementClass parent_class;
};

GType gst_ivorbisfile_get_type (void);

G_END_DECLS

#endif /* __GST_IVORBISFILE_H__ */
